unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ComCtrls,
  Vcl.Imaging.pngimage, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    btnRegistraEmisor: TButton;
    Image1: TImage;
    Label1: TLabel;
    TabSheet2: TTabSheet;
    btnTimbraCFDI: TButton;
    btnTimbraCFDI2: TButton;
    openDialog: TOpenDialog;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    TabSheet3: TTabSheet;
    btnConsulta: TButton;
    Label5: TLabel;
    txtRFCEmisor: TEdit;
    txtFolio: TEdit;
    Label6: TLabel;
    Cancelacion: TTabSheet;
    btnCancela: TButton;
    Label7: TLabel;
    txtRFCEmisor2: TEdit;
    txtFolio2: TEdit;
    Label8: TLabel;
    TabSheet4: TTabSheet;
    Memo1: TMemo;
    Label9: TLabel;
    procedure btnRegistraEmisorClick(Sender: TObject);
    procedure btnTimbraCFDIClick(Sender: TObject);
    procedure btnTimbraCFDI2Click(Sender: TObject);
    procedure btnConsultaClick(Sender: TObject);
    procedure btnCancelaClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Conector, ResultadoRegistro, Comprobante, ComprobanteEmisor, Ubicacion,
  ComprobanteEmisorRegimenFiscal, ComprobanteReceptor, ComprobanteConcepto,
  ComprobanteImpuestos, ComprobanteImpuestosTraslado, ResultadoTimbre, DateUtils, ResultadoConsulta,ResultadoCancelacion;

{$R *.dfm}

procedure TForm1.btnRegistraEmisorClick(Sender: TObject);
var
  conector: TConector;
  rfcEmisor: String;
  rutaCer: String;
  rutaKey: String;
  contrasena: String;
  resultadoRegistro: TResultadoRegistro;
begin

  //Este ejemplo utilizaremos los archivos que se encuentran en la carpeta ArchivosPrueba
            //En el ambiente productivo deberemos utilizar los archivos y contrasea originales de nuestro Emisor

            //Inicializamos el conector el parmetro indica el ambiente en el que se utilizar
            conector := TConector.Create('http://201.175.12.89/serviciointegracionpruebas/Timbrado.asmx');

            //Establecemos las credenciales para el permiso de conexin
            //Ambiente de pruebas = mvpNUXmQfK8=
            //Ambiente de produccin = Esta ser asignado por el proveedor al salir a productivo
            conector.EstableceCredenciales('mvpNUXmQfK8=');

            //Rfc Emisor
            rfcEmisor := 'AAA010101AAA';

            //Ruta del archivo .cer
            rutaCer := ExtractFileDir(application.ExeName) + '\ArchivosPrueba\aaa010101aaa__csd_01.cer';

            //Ruta del archivo .key
            rutaKey := ExtractFileDir(application.ExeName) + '\ArchivosPrueba\aaa010101aaa__csd_01.key';

            //Contrasea de la llave privada
            contrasena := '12345678a';

            //Registramos al Emisor por medio del conector y guardamos resultado
            resultadoRegistro := conector.RegistraEmisor(rfcEmisor, rutaCer, rutaKey, contrasena);

            //Verificamos el resultado
            if(resultadoRegistro.Exitoso) then
            begin
                //El Emisor fue registrado/actualizado correctamente
                showmessage('El Emisor fue registrado/actualizado correctamente');
            end
            else
            begin
                //Ocurri un error al registrar al Emisor
                showmessage(resultadoRegistro.Descripcion);
            end



end;

procedure TForm1.btnTimbraCFDIClick(Sender: TObject);
var
 conector: TConector;
 comprobante: TComprobante;
 resultadoTimbre: TResultadoTimbre;
 folioFiscal,noCertificado,noCertificadoSAT,fechaCert,selloCFDI,selloSAT,cadena: String;
begin
            //Este ejemplo est dirigido a aquellos integradores que an no generan el xml (CFDI)

            //Inicializamos el conector el parmetro indica el ambiente en el que se utilizar
            conector := TConector.Create('http://201.175.12.89/serviciointegracionpruebas/Timbrado.asmx');


            //Establecemos las credenciales para el permiso de conexin
            //Ambiente de pruebas = mvpNUXmQfK8=
            //Ambiente de produccin = Esta ser asignado por el proveedor al salir a productivo
            conector.EstableceCredenciales('mvpNUXmQfK8=');

            //Creamos un comprobante por medio de la entidad Comprobante
            comprobante := TComprobante.create();

            //Llenamos datos del comprobante
            comprobante.serie := 'F';
            comprobante.folio := '1';
            comprobante.fecha := incday(Now,-1);
            comprobante.formaDePago := 'Pago en una sola exhibicin';
            comprobante.metodoDePago := 'Transferencia bancaria';
            comprobante.subTotal := 100;
            comprobante.total := 116;
            //TIPO DE COMPROBANTE
            //Ingreso: Factura 1, Rec honorarios 4, rec de arrendamiento 5, Rec donativos 7, Nota de cargo 3
            //Egreso: Nota de credito 2
            //Traslado: Carta porte  6
            comprobante.tipoDeComprobante := TComprobanteTipoDeComprobante.ingreso;
            comprobante.LugarExpedicion := 'Mexico, Distrito Federal';

            //Llenamos datos del emisor
            comprobante.Emisor := TComprobanteEmisor.create();
            comprobante.Emisor.rfc := 'AAA010101AAA';
            comprobante.Emisor.nombre := 'Empresa de pruebas S.A. de C.V.';

            //Llenamos domicilio fiscal del emisor
            comprobante.Emisor.DomicilioFiscal := TUbicacion.create();
            comprobante.Emisor.DomicilioFiscal.calle := 'Calle pruebas';
            comprobante.Emisor.DomicilioFiscal.localidad := 'Localidad';
            //comprobante.Emisor.DomicilioFiscal.noExterior := '1';
            comprobante.Emisor.DomicilioFiscal.noInterior := 'A';
            comprobante.Emisor.DomicilioFiscal.colonia := 'Colonia pruebas';
            comprobante.Emisor.DomicilioFiscal.municipio := 'Municipio pruebas';
            comprobante.Emisor.DomicilioFiscal.estado := 'Estado pruebas';
            comprobante.Emisor.DomicilioFiscal.pais := 'Mexico';
            comprobante.Emisor.DomicilioFiscal.codigoPostal := '53125';

            //Llenamos regimen fiscal del emisor
            SetLength(comprobante.Emisor.RegimenFiscal, 1);
            comprobante.Emisor.RegimenFiscal[0] := TComprobanteEmisorRegimenFiscal.create();
            comprobante.Emisor.RegimenFiscal[0].Regimen := 'Regimen general de ley personas morales';

            //Llena datos de expedido en (Solo en caso de que el comprobante haya sido expedido en una sucursal y no en la matriz
            comprobante.Emisor.ExpedidoEn := TUbicacion.create();
            comprobante.Emisor.ExpedidoEn.calle := 'Calle expedido en';
            comprobante.Emisor.ExpedidoEn.noExterior := '2';
            comprobante.Emisor.ExpedidoEn.noInterior := '"B';
            comprobante.Emisor.ExpedidoEn.colonia := 'Colonia expedido en';
            comprobante.Emisor.ExpedidoEn.municipio := 'Municipio expedido en';
            comprobante.Emisor.ExpedidoEn.estado := 'Estado expedido en';
            comprobante.Emisor.ExpedidoEn.pais := 'Mexico';
            comprobante.Emisor.ExpedidoEn.codigoPostal := '53120';

            //Llena datos del receptor
            comprobante.Receptor := TComprobanteReceptor.create();
            comprobante.Receptor.rfc := 'BBB010101BBB';
            comprobante.Receptor.nombre := 'Cliente de prueba S.A. de C.V.';

            //Llena domicilio del receptor
            comprobante.Receptor.Domicilio := TUbicacion.create();
            comprobante.Receptor.Domicilio.calle := 'Calle cliente';
            comprobante.Receptor.Domicilio.noExterior := '3';
            comprobante.Receptor.Domicilio.noInterior := 'C';
            comprobante.Receptor.Domicilio.colonia := 'Colonia cliente';
            comprobante.Receptor.Domicilio.municipio := 'Municipio cliente';
            comprobante.Receptor.Domicilio.estado := 'Estado cliente';
            comprobante.Receptor.Domicilio.pais := 'Mxico';
            comprobante.Receptor.Domicilio.codigoPostal := '5';

            //Llenamos los conceptos
            SetLength(comprobante.Conceptos, 2);

            //Concepto 1
            comprobante.Conceptos[0] := TComprobanteConcepto.create();
            comprobante.Conceptos[0].cantidad := 1;
            comprobante.Conceptos[0].unidad := 'PZA';
            comprobante.Conceptos[0].noIdentificacion := '1';
            comprobante.Conceptos[0].descripcion := 'Prueba concepto 1';
            comprobante.Conceptos[0].valorUnitario := 50;
            comprobante.Conceptos[0].importe := 50;

            //Concepto 2
            comprobante.Conceptos[1] := TComprobanteConcepto.create();
            comprobante.Conceptos[1].cantidad := 1;
            comprobante.Conceptos[1].unidad := 'PZA';
            comprobante.Conceptos[1].noIdentificacion := '1';
            comprobante.Conceptos[1].descripcion := 'Prueba concepto 2';
            comprobante.Conceptos[1].valorUnitario := 50;
            comprobante.Conceptos[1].importe := 50;

            //Llenamos impuestos
            comprobante.Impuestos := TComprobanteImpuestos.create();
            comprobante.impuestos.totalImpuestosTrasladados:=16;
            SetLength(comprobante.Impuestos.Traslados, 1);
            comprobante.Impuestos.Traslados[0] := TComprobanteImpuestosTraslado.create();
            comprobante.Impuestos.Traslados[0].importe := 16;
            comprobante.Impuestos.Traslados[0].impuesto := TComprobanteImpuestosTrasladoImpuesto.IVA;
            comprobante.Impuestos.Traslados[0].tasa := 16;

            //Timbramos el CFDI por medio del conector y guardamos resultado
            resultadoTimbre := conector.TimbraCFDI(comprobante);

            //Verificamos el resultado

            if(resultadoTimbre.Exitoso)  then
            begin

                //Guardamos xml cfdi
                if(resultadoTimbre.GuardaXml(ExtractFileDir(Application.ExeName), '\comp.xml')) then
                begin
                    showmessage('El xml fue guardado correctamente');
                end
                else
                begin
                    showmessage('Ocurri un error al guardar el comprobante');
                end;


                //Los siguientes datos debern ir en la respresentacin impresa  PDF

                //1.- Cdigo bidimensional
                if(resultadoTimbre.GuardaCodigoBidimensional(ExtractFileDir(Application.ExeName), '\cb.jpg')) then
                 begin
                    showmessage('El cdigo bidimensional fue guardado correctamente');
                end
                else
                begin
                    showmessage('"Ocurri un error al guardar el cdigo bidimensional');
                end;


                //2.- Folio fiscal
                folioFiscal  := resultadoTimbre.FolioUUID;

                //3.- No. Certificado del Emisor
                noCertificado  := resultadoTimbre.No_Certificado;

                //4.- No. Certificado del SAT
                noCertificadoSAT  := resultadoTimbre.No_Certificado_SAT;

                //5.- Fecha y Hora de certificacin
                fechaCert  := resultadoTimbre.FechaCertificacion;

                //6.- Sello del cfdi
                selloCFDI  := resultadoTimbre.SelloCFDI;

                //7.- Sello del SAT
                selloSAT  := resultadoTimbre.SelloSAT;

                //8.- Cadena original de complemento de certificacin
                cadena  := resultadoTimbre.CadenaTimbre;

               showmessage('Timbrado Exitoso');


            end
            else
            begin
                //No se pudo timbrar, mostramos respuesta
                showmessage(resultadoTimbre.Descripcion);
            end;




end;

procedure TForm1.btnTimbraCFDI2Click(Sender: TObject);
var
 conector: TConector;
 resultadoTimbre: TResultadoTimbre;
 folioFiscal,noCertificado,noCertificadoSAT,fechaCert,selloCFDI,selloSAT,cadena: String;
begin

            //Inicializamos el conector el parmetro indica el ambiente en el que se utilizar
            conector := TConector.Create('http://201.175.12.89/serviciointegracionpruebas/Timbrado.asmx');


            //Establecemos las credenciales para el permiso de conexin
            //Ambiente de pruebas = mvpNUXmQfK8=
            //Ambiente de produccin = Esta ser asignado por el proveedor al salir a productivo
            conector.EstableceCredenciales('mvpNUXmQfK8=');

            // Set up the starting directory to be the current one
            openDialog.InitialDir := GetCurrentDir;

            // Only allow existing files to be selected
            openDialog.Options := [ofFileMustExist];

            // Allow only .dpr and .pas files to be selected
            openDialog.Filter := 'Comprobante CFDI|*.xml|';

            // Select pascal files as the starting filter type
            //openDialog.FilterIndex := 2;

            // Display the open file dialog
            if openDialog.Execute then
            begin
                 //Timbramos el CFDI por medio del conector y guardamos resultado
                      resultadoTimbre := conector.TimbraCFDI(openDialog.FileName);

                      //Verificamos el resultado

                      if(resultadoTimbre.Exitoso)  then
                      begin

                          //Guardamos xml cfdi
                          if(resultadoTimbre.GuardaXml(ExtractFileDir(Application.ExeName), '\comp.xml')) then
                          begin
                              showmessage('El xml fue guardado correctamente');
                          end
                          else
                          begin
                              showmessage('Ocurri un error al guardar el comprobante');
                          end;


                          //Los siguientes datos debern ir en la respresentacin impresa  PDF

                          //1.- Cdigo bidimensional
                          if(resultadoTimbre.GuardaCodigoBidimensional(ExtractFileDir(Application.ExeName), '\cb.jpg')) then
                           begin
                              showmessage('El cdigo bidimensional fue guardado correctamente');
                          end
                          else
                          begin
                              showmessage('"Ocurri un error al guardar el cdigo bidimensional');
                          end;


                          //2.- Folio fiscal
                          folioFiscal  := resultadoTimbre.FolioUUID;

                          //3.- No. Certificado del Emisor
                          noCertificado  := resultadoTimbre.No_Certificado;

                          //4.- No. Certificado del SAT
                          noCertificadoSAT  := resultadoTimbre.No_Certificado_SAT;

                          //5.- Fecha y Hora de certificacin
                          fechaCert  := resultadoTimbre.FechaCertificacion;

                          //6.- Sello del cfdi
                          selloCFDI  := resultadoTimbre.SelloCFDI;

                          //7.- Sello del SAT
                          selloSAT  := resultadoTimbre.SelloSAT;

                          //8.- Cadena original de complemento de certificacin
                          cadena  := resultadoTimbre.CadenaTimbre;

                         showmessage('Timbrado Exitoso');


                      end
                      else
                      begin
                          //No se pudo timbrar, mostramos respuesta
                          showmessage(resultadoTimbre.Descripcion);
                      end;
            end;



end;

procedure TForm1.btnCancelaClick(Sender: TObject);
var
 conector: TConector;
 resultadoCancelacion: TResultadoCancelacion;
begin


            //Inicializamos el conector el parmetro indica el ambiente en el que se utilizar
            conector := TConector.Create('http://201.175.12.89/serviciointegracionpruebas/Timbrado.asmx');


            //Establecemos las credenciales para el permiso de conexin
            //Ambiente de pruebas = mvpNUXmQfK8=
            //Ambiente de produccin = Esta ser asignado por el proveedor al salir a productivo
            conector.EstableceCredenciales('mvpNUXmQfK8=');

            //Obtenemos el xml por medio del conector y guardamos resultado
            resultadoCancelacion := conector.CancelaCFDI(txtRFCEmisor2.Text, txtFolio2.Text);

            //Verificamos el resultado
            if(resultadoCancelacion.Exitoso)  then
            begin
                 showmessage('Cancelacin exitosa ' + resultadoCancelacion.Descripcion)

            end
             else
              begin
                  //No se pudo cancelar, mostramos respuesta
                  showmessage(resultadoCancelacion.Descripcion);
              end;

end;

procedure TForm1.btnConsultaClick(Sender: TObject);
var
 conector: TConector;
 resultadoConsulta: TResultadoConsulta;
begin


            //Inicializamos el conector el parmetro indica el ambiente en el que se utilizar
            conector := TConector.Create('http://201.175.12.89/serviciointegracionpruebas/Timbrado.asmx');


            //Establecemos las credenciales para el permiso de conexin
            //Ambiente de pruebas = mvpNUXmQfK8=
            //Ambiente de produccin = Esta ser asignado por el proveedor al salir a productivo
            conector.EstableceCredenciales('mvpNUXmQfK8=');

            //Obtenemos el xml por medio del conector y guardamos resultado
            resultadoConsulta := conector.ObtieneCFDI(txtRFCEmisor.Text, txtFolio.Text);

            //Verificamos el resultado
            if(resultadoConsulta.Exitoso)  then
            begin

                //Guardamos xml cfdi
                if(resultadoConsulta.GuardaXml(ExtractFileDir(Application.ExeName), '\res.xml')) then
                begin
                    showmessage('El xml fue guardado correctamente');
                end
                else
                begin
                    showmessage('Ocurri un error al guardar el comprobante');
                end;
            end
             else
              begin
                  //No se pudo consultar, mostramos respuesta
                  showmessage(resultadoConsulta.Descripcion);
              end;

end;

end.
